/************************************************************
 **
 ** cmdd.h : p-code structure handling declarations
 **
 ** Copyright (c) 2004-2005, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef cmdd_h__
#define cmdd_h__

#include "pf_src.h"
#include "pf_proc.h"
#include "cmd.h"
#include "cmd_brdc.h"
#include "cmd_opdc.h"
#include "cmd_asmd.h"

struct cmd_ {
  cmd_t             link;
  flag_t            flags;
  pfile_pos_t       pos;         /* file & line       */
  cmd_type_t        type;        /* type of command   */
  const cmd_vtbl_t *vtbl;
  union {
    label_t          label;      /* line label        */
    cmd_branch_t     br;
    cmd_op_t         op;
    cmd_asm_t        op_asm;     /* inline assembly   */
    pfile_proc_t    *proc;       /* for {enter,leave} */
    variable_const_t usec_delay; /* usec_delay        */
  } u;
};

struct cmd_ *cmd_element_seek(cmd_t cmd, boolean_t mod);

#endif /* cmdd_h__ */

